#CONTROLCODES 1

DIR.STACK=63
DIR.LEVEL=0
DEVICE=8
DEF FN SW(W)=W+65536*(W>32767): REM CONVERT TO SIGNED RANGE

SCREEN 0
COLOR 1,0
CLS


PRINT "SET SYSTEM VARS"
GOSUB SETREGVARS
PRINT "GET CWD"
GOSUB GetCWD

PRINT "{WHT}INITIAL DIRECTORY"
PRINT "GOT CWD {GRN}";CWD$
PRINT
PRINT "{WHT}WAIT {LIGHT GREEN}3{WHT} SECONDS":SLEEP 180

FOR t = 1 TO 16
  New.Dir$="FOLDER"+MID$(STR$(t),2)
  DOS "MD:"+New.Dir$
  PRINT
  PRINT "{WHT}CWD: {GRN}";CWD$
  PRINT "{WHT}NEW DIR:{GRN} ";New.Dir$
  PRINT "{WHT}DIR PTR: {GRN}${YEL}";HEX$(DIR.PTR)
  PRINT "{WHT}DIR LEVEL:{GRN}";DIR.LEVEL
  GOSUB PUSHDIR
Next t
PRINT:PRINT
PRINT "{WHT}DONE PUSH LOOP"
PRINT "{WHT}FINAL DIRECTORY: {GRN}";CWD$
PRINT "{WHT}DIR LEVEL:{LIGHT GREEN}";DIR.LEVEL;"{WHT}{CR}{CR}"

PRINT:PRINT "{WHT}STARTING POP LOOP IN {LIGHT GREEN}10{WHT} SECONDS":SLEEP 600

FoldNum=10
POPLOOP:
  PRINT
  Old.Dir$="FOLDER"+MID$(STR$(DIR.LEVEL),2)
  PRINT "{WHT}CWD: {GRN}";CWD$
  PRINT "{WHT}OLD DIR:{GRN} ";Old.Dir$
  PRINT "{WHT}DIR PTR: {GRN}${YEL}";HEX$(DIR.PTR)
  PRINT "{WHT}DIR LEVEL:{GRN}";DIR.LEVEL
  GOSUB POPDIR
  DOS "RD:"+Old.Dir$
  IF DIR.LEVEL>0 THEN POPLOOP

  PRINT
  PRINT "{WHT}FINAL WORKING DIRECTORY: {GRN}";CWD$;"{WHT}"
  PRINT "{WHT}DIR PTR: {GRN}${YEL}";HEX$(DIR.PTR)
  PRINT
  COLOR 1,0
  END



PUSHDIR:
 If Dir.Level=0 THEN Dir.Ptr = $C000
 S$=CWD$
 OPEN 15,DEVICE,15,"CD:"+New.Dir$
 INPUT#15,DE%,FC$,A,Z:CLOSE 15
 DE%=(DE%<21)
 IF NOT DE% THEN DIR.ERROR
 HAS.SLASH=0
   FOR Z=1 TO LEN(New.Dir$):IF MID$(New.Dir$,Z,1)="/" THEN HAS.SLASH=TRUE:Z=LEN(New.Dir$)
   NEXT Z
 IF NOT HAS.SLASH THEN S$="../"
 Sub.Ptr=LEN(S$)+1
 SAddr=Dir.Ptr - Sub.Ptr
 IF SAddr<$A000 THEN DirStack.Overflow
 BANK Dir.Stack
 GOSUB POKE.STRING
 Dir.Ptr=Dir.Ptr - Sub.Ptr
 Dir.Level=Dir.Level + 1
 GOSUB GetCWD
 RETURN

POPDIR:
 If Dir.Level=0 THEN DirStack.Overflow
 SAddr=Dir.Ptr
 BANK Dir.Stack
 GOSUB PEEK.STRING
 Add.Ptr=  LEN(S$)+1
 Dir.Ptr = Dir.Ptr + Add.Ptr
 IF Dir.Ptr>$C000 THEN PRINT S$;" ";HEX$(Dir.Ptr):GOTO DirStack.Overflow
 OPEN 15,DEVICE,15,"CD:"+S$
 INPUT#15,DE%,FC$,A,Z:CLOSE 15
 CLOSE 15
 DE%=(DE%<21)
 IF NOT DE% THEN POPDIR.ERROR
 GOSUB GetCWD$
 Dir.Level=Dir.Level - 1
 RETURN

DirStack.Overflow:
 PRINT "{CR}{LIGHT RED}DIR STACK OVERFLOW/UNDERFLOW. DIR.PTR=";HEX$(Dir.Ptr);"    CWD: ";CWD$
 PRINT:SLEEP 60:GOTO DUMPSTACK
 END

DIR.ERROR:
 PRINT "{CR}{LIGHT RED} PUSHING DIRECTORY ERROR {YEL}";New.Dir$;"{LIGHT GREEN} !!{CR}"
 PRINT:SLEEP 60:GOTO DUMPSTACK

POPDIR.ERROR:
 PRINT "{CR}{LIGHT RED}POPPING DIRECTORY ERROR {LIGHT GREEN}!!{CR}"
 PRINT:SLEEP 60:GOTO DUMPSTACK

PEEK.STRING:
 L=PEEK(SAddr):IF L=0 THEN S$="":RETURN
 S$=RPT$(32,L)
 ADDR=SAddr+1
 POKE R0L, FN SW(ADDR) AND $00FF
 POKE R0H, INT(ADDR/256)
 P=POINTER(S$)
 POKE R1L, PEEK(P+1)
 POKE R1H, PEEK(P+2)
 POKE R2L, L
 POKE R2H, 0
 SYS MEM.COPY
 RETURN

POKE.STRING:
 L=LEN(S$)
 Addr=SAddr+1
 POKE SAddr, L
 POKE R1L, FN SW(ADDR) AND $00FF
 POKE R1H, INT(ADDR/256)
 P=POINTER(S$)
 POKE R0L, PEEK(P+1)
 POKE R0H, PEEK(P+2)
 POKE R2L, L
 POKE R2H, 0
 SYS MEM.COPY
 RETURN

DUMPSTACK:
   INPUT Y
   CLS
   BANK Dir.Stack
   PTR=$BFFF
DUMPLOOP:
   GET X$:IF X$="{ESC}" THEN END
   PRINT HEX$(PTR);" ";CHR$(PEEK(PTR))
   SLEEP 20
   PTR=PTR-1
   GOTO DUMPLOOP
   DOS "CD:/"
   END



GetCWD:
  CWD$=""
  OPEN 8, DEVICE, 0, "$=C"
  GET# 8, X$: GET# 8, X$: REM SKIP LOAD ADDR
  ## SKIP VOLUME LABEL
  GET# 8, X$: GET# 8, X$: GET# 8, X$: GET# 8, X$: LINPUT# 8, X$, 0
CWD.Loop:
  GET# 8, X$: GET# 8, X$: GET# 8, X$: GET# 8, X$: REM SKIP LINK AND SIZE
  LINPUT# 8, X$, 34: REM SKIP TO FIRST QUOTE
  LINPUT# 8, D$, 34: REM READ TO NEXT QUOTE
  LINPUT# 8, X$,  0: REM SKIP TO END OF ENTRY
  IF (LEN(D$)<>0) AND ASC(D$) THEN GOSUB CWD.Builder
  IF (ST AND 64) = 0 THEN CWD.Loop
  CLOSE 8
  RETURN

CWD.Builder:
  IF LEN(CWD$) AND (D$ <> "/") THEN CWD$ = "/" + CWD$
  FOR I=LEN(D$) TO 1 STEP -1
    C$ = MID$(D$, I, 1): C=ASC(C$)
    IF (C >  96) AND (C < 123) THEN C = C -  32
    IF (C > 192) AND (C < 219) THEN C = C - 128
    CWD$ = CHR$(C) + CWD$
  NEXT
  RETURN


  SETREGVARS:
  ONE=1
  TWO=2
  THREE=3
  FOUR=4
  A.REG = $030C
  X.REG = $030D
  Y.REG = $030E
  C.REG = $030F
  MEM.TOP = $FF99
  R0L=$02:R0H=$03:R0=R0L
  R1L=$04:R1H=$05:R1=R1L
  R2L=$06:R2H=$07:R2=R2L
  R3L=$08:R3H=$09:R3=R3L
  R4L=$A:R4H=$B:R4=R4L
  R5L=$C:R5H=$D:R5=R5L
  R6L=$E:R6H=$F:R6=R6L
  R7L=$10:R7H=$11:R7=R7L
  R8L=$12:R8H=$13:R8=R8L
  R9L=$14:R9H=$15:R9=R9L
  R10L=$16:R10H=$17:R10=R10L
  R11L=$18:R11H=$19:R11=R11L
  R12L=$1A:R12H=$1B:R12=R12L
  R13L=$1C:R13H=$1D:R13=R13L
  R14L=$1E:R14H=$1F:R14=R14L
  R15L=$20:R15H=$21:R15=R15L
  SET.CHARSET = $FF62
  FB.SET.PIXELS = $FF0E
  FB.CURSOR.POSITION = $FEFF
  FB.CURSOR.NEXTLINE = $FF02
  SETLFS = $FFBA
  CHKOUT = $FFC9
  CHKIN = $FFC6
  CLRCHN = $FFCC
  MCIOUT = $FEB1
  MACPTR = $FF44
  MEM.COPY = $FEE7
  VERA.LOWADDR = $9F20
  VERA.MIDADDR = $9F21
  VERA.HIGHADDR = $9F22
  VERA.DATA0 = $9F23
  VERA.DATA1 = $9F24
  VERA.CTRL = $9F25
  VERA.DCVIDEO=$9F29
  SCREEN.SIZE = $12C00
  LAYER0.ON=16
  LAYER0.OFF=239
  LAYER1.ON=32
  LAYER1.OFF=223
  XLIMIT=319
  YLIMIT=239
  ZERO=0
  FALSE=ZERO
  TRUE=NOT FALSE
  RETURN
